models/Establecimientos.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "establecimientos".
 *
 * @property int $codigo
 * @property string|null $nombre
 * @property string|null $dirección
 * @property string|null $imagen_establecimiento
 * @property int|null $valoracion
 *
 * @property Telefonos[] $telefonos
 * @property Vende[] $vendes
 */
class Establecimientos extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'establecimientos';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['valoracion'], 'integer'],
            [['nombre'], 'string', 'max' => 50],
            [['dirección', 'imagen_establecimiento'], 'string', 'max' => 1000],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'codigo' => 'Codigo',
            'nombre' => 'Nombre',
            'dirección' => 'Dirección',
            'imagen_establecimiento' => 'Imagen Establecimiento',
            'valoracion' => 'Valoracion',
        ];
    }

    /**
     * Gets query for [[Telefonos]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getTelefonos()
    {
        return $this->hasMany(Telefonos::className(), ['codigo_establecimiento' => 'codigo']);
    }

    /**
     * Gets query for [[Vendes]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getVendes()
    {
        return $this->hasMany(Vende::className(), ['codigo_establecimiento' => 'codigo']);
    }
}

controllers/EstablecimientosController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Establecimientos;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EstablecimientosController implements the CRUD actions for Establecimientos model.
 */
class EstablecimientosController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Establecimientos models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Establecimientos::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Establecimientos model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Establecimientos model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Establecimientos();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['establecimientos/mostrarestablecimientos', 'id' => $model->codigo]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Establecimientos model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['establecimientos/mostrarestablecimientos', 'id' => $model->codigo]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Establecimientos model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['establecimientos/mostrarestablecimientos']);
    }

    /**
     * Finds the Establecimientos model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Establecimientos the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Establecimientos::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionMostrarestablecimientos(){    //esta acción recibe como parámetro los establecimientos y los muestra
        $dataProvider=new ActiveDataProvider([          
            'query'=>Establecimientos::find(),         //con esta consulta hacemos que nos muestre todos los establecimientos
            
           
                ]);
                return $this->render("establecimientos",[  //renderizo en en el archivo php "establecimientos"
                    
                    "dataProvider"=>$dataProvider,
            ]);
    }
}

views/establecimientos/_establecimiento.php
<?php

use yii\helpers\Html;
use kartik\rating\StarRating;
use yii\widgets\ActiveForm;


$this->title = "Establecimientos";   //ponemos el titulo que aparece en el head
?>

<div class="caja">
    <div class="col-md-12">
        <!--        con col-md modulamos en que tipo de formato lo queremos-->
        <div class="thumbnail">
         
            <div class="caption">
                <?=Html::img($model->imagen_establecimiento) ?>
                <h3><?= $model->nombre?></h3>
                <!--  pongo el dato procedente del modelo al que procede en este caso al del establecimiento    -->
                <p>Dirección: <?= $model->dirección ?> </p>
                 
                <p class="StarRating">
                     <?=
                    StarRating::widget([
    'name' => 'rating_35',
    'value' =>$model->valoracion ,
    'pluginOptions' => ['displayOnly' => true,
        'filledStar' => '&#x2605;',
        'emptyStar' => '&#x2606;']
]);
                    ?>
                    
     
                </p>
      <?= Html::a('Actualizar', ['establecimientos/update', 'id' => $model->codigo], ['class' => 'btn btn-primary']) ?>
                     <?= Html::a('Eliminar', ['establecimientos/delete', 'id' => $model->codigo], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => '¿Estás seguro de querer borrar este elemento?',
                'method' => 'post',
            ],//en los botones de actualizar eliminar ponemos "establecimientos/update" y "establecimientos/delete" y especificamos el botón. Para enlazarlos con los archivos php que realizan estas acciones, eso si en las views correspondientes
                                //al ser comics necesita la id con la que se identifica, en este caso código
        ]) ?>       
            </div>
        </div>
    </div>
</div>

views/establecimientos/_form.php
<?php

use yii\helpers\Html;
use kartik\form\ActiveForm;
use kartik\builder\Form;
use kartik\rating\StarRating;

/* @var $this yii\web\View */
/* @var $model app\models\Establecimientos */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="establecimientos-form"> 
    <?php $form = ActiveForm::begin() ?>
    <?=
    Form::widget([// fields with labels
        'model' => $model,
        'form' => $form,
        'columns' => 2,
        'attributes' => [
            'nombre' => ['label' => 'Nombre del establecimiento', 'options' => ['placeholder' => 'Introduce nombre del establecimiento']],
            'dirección' => ['label' => 'Dirección del establecimiento', 'options' => ['placeholder' => 'Introduce dirección del establecimiento']],
        ]
    ])
    ?>
    <?=
    Form::widget([// continuation fields to row above without labels
        'model' => $model,
        'form' => $form,
        'columns' => 2,
        'attributes' => [
            'imagen_establecimiento' => ['label' => 'Foto del establecimiento', 'options' => ['placeholder' => 'Introduce la imagen del establecimiento,ejemplo:@carpeta/carpeta/foto.jpg']],
        ]
    ])
    ?>
    <?=
    $form->field($model, 'valoracion')->widget(StarRating::classname(), [
        'pluginOptions' => ['step' => 1,
            'filledStar' => '&#x2605;',
            'emptyStar' => '&#x2606;',
        ]
    ]);
    ?>

    <div class="form-group">  
        <?= Html::resetButton('Restablecer', ['class' => 'btn btn-light']) ?>


        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success']) ?>
    </div>
    <?php ActiveForm::end(); ?>
</div>

views/establecimientos/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Establecimientos */

$this->title = 'Introduce un nuevo establecimiento'; //el titulo de la sección para crear un nuevo establecimiento

?>
<div class="establecimientos-create">

    <h2><?= Html::encode($this->title) ?></h2>   
    
    <?= $this->render('_form', [
        'model' => $model,         //Renderiza en los modelos que se encuentran en el formulario de establecimientos
    ]) ?>

</div>

views/establecimientos/establecimientos.php
<?php

use yii\helpers\Html;
use yii\helpers\HtmlPurifier;
use yii\widgets\ListView;

$titulo = "ESTABLECIMIENTOS";             //ponemos el titulo que aparece en el head
?>

<h2 style="text-align: center; max-height: 50px;"><?= $titulo ?></h2>
<div class="linea_recta"></div>
<div class="texto_titulo">En esta sección podreís visualizar la informción de todas los establecimientos, también teneis la opción de incluir vuestras propias sugerencias incluyendo la editorial que querais, para compartirlo con el resto de usuarios.</div>
<p>

<p>

<?= Html::a('Introducir nuevo establecimiento', ['establecimientos/create'], ['class' => 'btn btn-warning']) ?>
</p>


<div class="row">
    <?=
    ListView::widget([                    //con esta parte de código cambiamos la vista de un Grid View a un ListView
        'dataProvider' => $dataProvider,
        'itemView' => '_establecimiento',      // vinculamos este archivo php con otro
        'layout' => "{pager}\n{items}",
    ]);
    ?>   

</div>

views/establecimientos/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Establecimientos';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="establecimientos-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Establecimientos', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'codigo',
            'nombre',
            'dirección',
            'imagen_establecimiento',
            'valoracion',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/establecimientos/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Establecimientos */

$this->title = 'Actualiza la información del establecimiento: ' . $model->nombre;

?>
<div class="establecimientos-update">

    <h2><?= Html::encode($this->title) ?></h2>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/establecimientos/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Establecimientos */

$this->title = $model->codigo;
$this->params['breadcrumbs'][] = ['label' => 'Establecimientos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="establecimientos-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->codigo], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->codigo], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'codigo',
            'nombre',
            'dirección',
            'imagen_establecimiento',
            'valoracion',
        ],
    ]) ?>

</div>